#!/usr/bin/tclsh
#
# Copyright (c) 1999-2001, ``vman'' (moopowah@yahoo.com)
# All rights reserved.  Please refer to the LICENSE file
# included in vCheck's package for more information, or
# the homepage http://vware.hypermart.net.
#
#	Description:
#
#		If arguments are sent to this script, each one is assumed to be a dir
#		relative to ROOTPATH and its entries are removed from the database.  If
#		no arguments are sent, then it queries the incomplete releases table to
#		confirm that the dirs (releases) claiming to be incomplete still exist
#		on the site (some releases may be nuked while uploading, or deleted,
#		etc) -- if not, they are removed from the incomplete releases table.
#
set cleanIncompletesRevision "Jan/24/2001"
#
################################################################################




source "/bin/vcheck/dbLogin.tcl"

# Is an external process calling me to force a flush?
if {[llength $argv] > 0} {
	set a 0
	foreach toFlush $argv {
		vcheck:db:query "SELECT fullDir, releaseId FROM Releases WHERE fullDir='$toFlush';"
		foreach {dir rid} [join $rows] {
			vcheck:db:removeRelease $rid
			puts "([incr a]) DELETED: $dir"
		}
	}
	vcheck:db:safeExit 0
}

set a 0
vcheck:db:query "SELECT fullDir, IncompleteReleases.releaseId FROM IncompleteReleases LEFT JOIN Releases USING (releaseId) GROUP BY IncompleteReleases.releaseId;"
foreach {dir rid} [join $rows] {
	if {(![file isdirectory "$glftpdDir/$dir"]) || ($dir == "")} {
		sql exec $db(conn) "DELETE FROM IncompleteReleases WHERE releaseId=$rid;"
		puts "([incr a]) DELETED: $dir (rid #$rid)"
	}
}

vcheck:db:safeExit 0

