#!/bin/tclsh
#
# Copyright (c) 1999-2001, ``vman'' (moopowah@yahoo.com)
# All rights reserved.  Please refer to the LICENSE file
# included in vCheck's package for more information, or
# the homepage http://vware.hypermart.net.
#
#	Description:
#
#		The name says it all -- this script deletes symlinks that lead to
#		non-existent dirs (aka, dead links).  You *can not* run this file
#		as you would think, or you'll delete all of symlinks!!  It needs to
#		be run inside glftpd's environment.  What does that mean?  Observe the
#		example below:
#			chroot /glftpd /bin/vcheck/cleanLinks.tcl
#		Where "/glftpd" is your ROOTPATH and "/bin/vcheck/cleanLinks.tcl" exists
#		relative to that ROOTPATH; thus, /glftpd/bin/vcheck/cleanLinks.tcl.
#		Also keep in mind the shebang (you know, that funky line at the top
#		that starts with #!) is relative to the ROOTPATH!
#
set cleanLinksRevision "Jan/24/2001"
#
################################################################################
# Clean symlinks inside the dirs listed here; one dir per line (use braces if
# it has spaces in the name or strange characters like brackets).  All paths
# are relative to glftpd's ROOTPATH!
set cleanDirs {
	/site/INCOMPLETES
}

# Same as above, except it'll clean the symlinks inside the dirs you list here;
# confused now eh?  Take the example...best use is for the mp3 genre symlinks:
# you want to check the symlinks not in mp3-by-genre, but inside each and every
# dir *within* mp3-by-genre, such as "Rap", "R&B", etc. :-)
set cleanSubDirs {
	/site/mp3-by-group
	/site/mp3-by-genre
	/site/mp3-by-title
}
################################################################################




set myLinks ""
# Generate a list of the links we will verify exist.
foreach dir $cleanDirs {
	append myLinks "[glob -nocomplain "$dir/*"] "
}
foreach subDir $cleanSubDirs {
	set myDirs [glob -nocomplain "$subDir/*"]
	foreach dir $myDirs {
		append myLinks "[glob -nocomplain "$dir/*"] "
	}
}

# Now check the links' existence.
set a 0
foreach dir $myLinks {
	if {![file isdirectory $dir]} {
		file delete -force -- $dir
		puts "([incr a]) DELETED: $dir"
	}
}

exit 0

