#!/usr/bin/tclsh
#
# Copyright (c) 1999-2001, ``vman'' (moopowah@yahoo.com)
# All rights reserved.  Please refer to the LICENSE file
# included in vCheck's package for more information, or
# the homepage http://vware.hypermart.net.
#
#	Description:
#
#		This is meant to keep the vcheck database clean overall.  This is based
#		on how old the entry is in the database and whether or not the release
#		still exists in the site.
#
set cleanReleasesRevision "Jan/24/2001"
#
################################################################################
# Keep ONLY those records whose dir currently exists? (0/1)
set keepCurrent	0

# Keep records at most this many days old before removing (integer, 0 to disable)
set keepAge	0
################################################################################




source "/bin/vcheck/dbLogin.tcl"

if {$keepCurrent != 0} {
	set a 0
	vcheck:db:query "SELECT fullDir, releaseId FROM Releases;"
	foreach {dir rid} [join $rows] {
		if {![file isdirectory "$glftpdDir/$dir"]} {
			vcheck:db:removeRelease $rid
			puts "([incr a]) DELETED: $dir"
		}
	}
}

if {$keepAge > 0} {
	# Convert days to seconds.
	set keepAge [expr $keepAge * 86400]
	# Now $keepAge represents the upper-limit for records to keep (in UNIX time--long int)
	set keepAge [expr [clock seconds] - $keepAge]
	# Convert from long int to DATETIME
	set keepAge [clock format $keepAge -format "%Y-%m-%d %H:%M:%S"]
	vcheck:db:query "SELECT fullDir, releaseId FROM Releases WHERE timeStamp<='$keepAge';"
	set a 0
	foreach {dir rid} [join $rows] {
		vcheck:db:removeRelease $rid
		puts "([incr a]) DELETED: $dir"
	}
}

vcheck:db:safeExit 0

