#!/usr/bin/tclsh
#
# Copyright (c) 1999-2001, ``vman'' (moopowah@yahoo.com)
# All rights reserved.  Please refer to the LICENSE file
# included in vCheck's package for more information, or
# the homepage http://vware.hypermart.net.
#
#	Description:
#
#		This is the main configuration file for various external scripts which
#		vCheck uses.  Some procedures are here too that are used frequently
#		(let's call them helper functions).  Refer to the "various scripts"
#		and if they don't work, make sure they are referencing *this* file
#		with the correct path.
#
set dbLoginRevision "Jan/24/2001"
#
################################################################################
set db(login)	"vcheck"
set db(pass)	"kcehcv99"
set db(host)	"127.0.0.1"
set db(table)	"vcheck"

# Where is glftpd installed (ROOTPATH).  if you are running this script
# as a site_cmd then set this value to "/" (string)
set glftpdDir	"/glftpd"
################################################################################




load /usr/lib/sql.so	;# where's the MySQL-Tcl API?
set db(conn) [sql connect $db(host) $db(login) $db(pass)]
sql selectdb $db(conn) $db(table)


proc vcheck:db:safeExit {exitStatus} { global db tcl_platform
	# FreeBSD dies when trying to end the session with mysqld (probably because the tcl-sql is for an older version and we're forcing it on newer msyql daemons).
	catch {sql endquery $db(conn)}
	if {($tcl_platform(os) != "FreeBSD") && ($db(conn) != "") && ([catch {sql disconnect $db(conn)} err])} {
		puts "Failure: Database disconnection: $err"
	}
	# Goodbye... :-)
	exit $exitStatus
}


proc vcheck:db:query {myQuery} { global db
	# Take in the query line, query the db, and create the list $rows to the caller's proc level.
	sql query $db(conn) $myQuery
	upvar 1 rows rows
	set rows ""
	while {[set row [sql fetchrow $db(conn)]] != ""} {
		if {[llength $row] != 1} {
			lappend rows $row
		} else {
			lappend rows [lindex $row 0]
		}
	}
	catch {sql endquery $db(conn)}
	if {([string index $rows 0] == "\{") && ([llength $rows] == 1)} {
		set rows [lindex $rows 0]
	}
	return 0
}


proc vcheck:db:removeRelease {rid} { global db
	sql exec $db(conn) "DELETE FROM Releases WHERE releaseId=$rid;"
	sql exec $db(conn) "DELETE FROM ReleasesDetails WHERE releaseId=$rid;"
	sql exec $db(conn) "DELETE FROM Mp3Releases WHERE releaseId=$rid;"
}

