#
# Copyright (c) 1999-2001, ``vman'' (moopowah@yahoo.com)
# All rights reserved.  Please refer to the LICENSE file
# included in vCheck's package for more information, or
# the homepage http://vware.hypermart.net.
#
#	Description:
#
#		This sitebot accompanies the vCheck package.  The other file you should
#		have a look at is sitebot.conf.  This script ultimately posts data to
#		irc (that data it receives on a particular channel).  Yes, you load this
#		script from eggdrop! :-)
#
set vcheckSitebotRevision "Jan/25/2001"
#
####################################################################################################
set pubchans1			"#chan1"				;# what channels to echo completion
set pubchans2			"#chan1 #chan2"				;# what channels to echo newRacers

# set $announceFile to the logfile vCheck is writing to (full path to file); or
# set $announcePort if you are not using files to relay the posts, rather, which
# port you want to use as your Tcl socket server.  If you are using the latter,
# refer to $remoteMasks as well.  Again, ONLY SET ONE OF THESE!  Set the unused
# option to null ("").
set announceFile		""
set announcePort		"5599"

# If you are using a Tcl socket server on port $announcePort, then specify what
# remote hosts to allow access to it (i.e., a list of ips, with wildcars if you
# wish, to allow access to this server).  Intruders (i.e., those IPs that
# connect to $announcePort but are not in $remoteMasks) will be logged to
# VCHECK_INTRUDERS.txt (in eggdrop's home directory), as well as logged to
# eggdrop's default logfile via [putlog].  This will allow you to have your
# sitebot on machineA while vCheck is running on the ftp server which is
# machineB (more secure).  Encryption will follow if I have time to implement it,
# please refer to http://www.scriptics.com/ftp/tls/ if you wish to help in this
# area.
set remoteMasks {
	127.0.0.1
}

# If you know what this is, here it is; if not, don't worry. :-)
set divider "\^"
####################################################################################################




if {![info exists announceMe]} {
	if {$announceFile != ""} {
		set announceMe [open "|[exec -- which tail] -f -n0 $announceFile" r]
		fconfigure $announceMe -buffering line
		fileevent $announceMe readable "vcheck:announce $announceMe \"\" \"\""
	} else {
		set announceMe [socket -server vcheck:newSock $announcePort]
	}
}


proc vcheck:newSock {sock remoteHost remotePort} {
	# Got a connection from $remoteHost; setup a fileevent to execute based on line i/o.
	fconfigure $sock -buffering line
	fileevent $sock readable "vcheck:announce $sock $remoteHost $remotePort"
}


proc vcheck:announce {myChannel remoteHost remotePort} { global pubchans1 pubchans2 remoteMasks divider
	set line [gets $myChannel]

	if {$remoteHost != ""} {
		if {$line == ""} {
			# EOF for our socket, we don't want to kill the channel for `tail' ever.
			close $myChannel
			return 0
		}

		if {[lsearch $remoteMasks $remoteHost] == -1} {
			set fout [open VCHECK_INTRUDERS.txt a]
			puts $fout "remoteHost=$remoteHost remotePort=$remotePort dataLine=$line"
			putlog "VCHECK_INTRUDER: remoteHost=$remoteHost remotePort=$remotePort firstDataLine=$line"
			close $myChannel
			return 1
		}
	}

	set line [split $line $divider]
	switch -exact -- [lindex $line 0] {
		NEW_URACER {
			vcheck:putChans $pubchans2 [lindex $line 1]
		}

			RACE_COMPLETE {
			vcheck:putChans $pubchans1 [lindex $line 1]
		}
	}

	return 0
}


proc vcheck:putChans {chans data} {
	foreach chan $chans {
		putserv "PRIVMSG $chan :$data"
	}
	return 0
}


putlog "*** vCheck's sitebot revision $vcheckSitebotRevision loaded!"

